diff --git a/src/bin/pg_upgrade/pg_upgrade.c b/src/bin/pg_upgrade/pg_upgrade.c
index d95c491fb5..e51d18f0b1 100644
--- a/src/bin/pg_upgrade/pg_upgrade.c
+++ b/src/bin/pg_upgrade/pg_upgrade.c
@@ -436,7 +436,8 @@ set_locale_and_encoding(void)
 	PGconn	   *conn_new_template1;
 	char	   *datcollate_literal;
 	char	   *datctype_literal;
-	char	   *datlocale_literal = NULL;
+	char	   *datlocale_literal;
+	char	   *datlocale_src;
 	DbLocaleInfo *locale = old_cluster.template0;
 
 	prep_status("Setting locale and encoding for new cluster");
@@ -451,11 +452,12 @@ set_locale_and_encoding(void)
 									   locale->db_ctype,
 									   strlen(locale->db_ctype));
 	if (locale->db_locale)
-		datlocale_literal = PQescapeLiteral(conn_new_template1,
-											locale->db_locale,
-											strlen(locale->db_locale));
+		datlocale_src = locale->db_locale;
 	else
-		datlocale_literal = pg_strdup("NULL");
+		datlocale_src = "NULL";
+	datlocale_literal = PQescapeLiteral(conn_new_template1,
+										datlocale_src,
+										strlen(datlocale_src));
 
 	/* update template0 in new cluster */
 	if (GET_MAJOR_VERSION(new_cluster.major_version) >= 1700)
